"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validate = undefined;

var _data = require("data.validation");

var _data2 = _interopRequireDefault(_data);

var _ramda = require("ramda");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Success = _data2.default.Success;
var Failure = _data2.default.Failure;

var validate = (0, _ramda.curry)(function (validations, thing) {
  var initial = Success((0, _ramda.curryN)((0, _ramda.length)(validations), (0, _ramda.always)(thing)));

  var run = function run(acc, v) {
    return acc.ap(v.predicate(thing) ? Success(thing) : Failure([v.error]));
  };

  return (0, _ramda.reduce)(run, initial, validations);
});

exports.validate = validate;